unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AdvSmoothGauge, StdCtrls, OverbyteIcsWndControl, OverbyteIcsWSocket,
  AdvToolBtn, OoMisc, AdStatLt, ExtCtrls, OverbyteIcsWSocketS, RVOfficeRadioBtn,
  OverbyteIcsIniFiles, CheckLst, ComCtrls, RVOfficeCnv;

type TTrafficLight = (tlRed, tlYellow, tlGreen);

type
  TForm1 = class(TForm)
    AdvSmoothGauge2: TAdvSmoothGauge;
    DisplayMemoCliSocket: TMemo;
    Label7: TLabel;
    CliSocket: TWSocket;
    SendEdit: TEdit;
    ServerEdit: TEdit;
    Label9: TLabel;
    PortEditSockCLient: TEdit;
    Label8: TLabel;
    SendButtonForClientSocket: TButton;
    AddCRLFCheckBox: TCheckBox;
    AllowBinaryCheckBox: TCheckBox;
    DisconectButtonClientSocket: TButton;
    PortSocketServerEdit: TEdit;
    ChoiceTrybeWork: TRadioGroup;
    CloseProgram: TButton;
    //WSocketServer1: TWSocketServer;
    RVOfficeRadioGroup1: TRVOfficeRadioGroup;
    RVOfficeRadioGroupFirstExtend: TRVOfficeRadioGroup;
    HeaderAnalog: THeader;
    Label1: TLabel;
    HeaderControl1: THeaderControl;
    procedure SendButtonForClientSocketClick(Sender: TObject);
    procedure DisconectButtonClientSocketClick(Sender: TObject);
    procedure RVOfficeRadioGroup1Click(Sender: TObject);
    procedure RVOfficeRadioGroup1DblClickItem(Sender: TObject);
    procedure RVOfficeRadioGroupFirstExtendClick(Sender: TObject);
    procedure RVOfficeRadioGroupFirstExtendDblClickItem(Sender: TObject);
    //procedure RVOfficeRadioGroupSecondExtendClick(Sender: TObject);
    //procedure RVOfficeRadioGroupSecondExtendDblClickItem(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    //procedure WSocketServer1ClientConnect(Sender: TObject;
      //Client: TWSocketClient; Error: Word);
    //procedure WSocketServer1DataAvailable(Sender: TObject; ErrCode: Word);
    //procedure WSocketServer1SocksConnected(Sender: TObject; ErrCode: Word);
    procedure CliSocketDataAvailable(Sender: TObject; ErrCode: Word);
    procedure CliSocketSendData(Sender: TObject; BytesSent: Integer);
    procedure CliSocketSessionClosed(Sender: TObject; ErrCode: Word);
    procedure CliSocketSessionConnected(Sender: TObject; ErrCode: Word);
    procedure CloseProgramClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private declarations }
    var FIniFileName   : String;
        IniFileName ,IniFileNameServer : String;
        Initialized  ,InitializedServer: Boolean;
    procedure ExtractReceivedStringFromArduino_And_PutItInGraficElements(var StringReceived:string);
    procedure  SetStateSendEditComponent_and_RekordForArduino (var NrPinForSingle:integer ;
                                                                 var NoItemCorectedInRecordArduino: integer;
                                                                 TypePin:char);


  public
    { Public declarations }
    var Buffer       : array [0..1023] of AnsiChar;
    {w Sketchu
     const int NoOfDigitalPinsOnBoard = 11;
//const int NoOfDigitalPinsOnBoard = 13;
const int NoOfDigitalPinsOnExtendedPCF857X = 8;
    }
    const DataSeparator :char =  ' ' ;
          NoOfPinAnalogInArduinoBoard = 5;
          NoOfDigitalPinsOnBoard = 13;  //  for Arduino and ethernet
          NoOfDigitalPinsOnExtendedPCF857X = 8;

    type  TRekordForArduinoState =  record
                                AnalogState  : array[0..NoOfPinAnalogInArduinoBoard] of integer;
                                DigitalState : array[0..NoOfDigitalPinsOnBoard + NoOfDigitalPinsOnExtendedPCF857X] of boolean ;    //  For 1 extender PCF8574
                          end;
   var RekordForArduinoState: TRekordForArduinoState;
       RekordForArduinoPreviousState:TRekordForArduinoState;
       NoItemCorectedInRecordArduino: integer;
    var ExtractedStringData:AnsiString;
    var NotPresentNextDataInLine:boolean;
    var NrLineForAnalogInput : integer;
        LocationIinLLine                    : integer;
        FLightsSlots    :array[0..3] of boolean;
         //array of booleans called FLightsSlots

     type TTypeLine = (Analog, Digital,PCF8576,PCF8576_1,Null) ;
     var  TypeLine : TTypeLine;
          OwnIPAddress :string;
          TypeWork : byte ; //=I NO IP , S Single Pin read and set , A  All Pins   read and set ,
                            //C Close Client and Server in a remore arduino or Wifi

    Procedure ExtractDataFromLine(
                        Line:AnsiString;
                        var LocationIinLLine:integer;
                        var ExtractedStringData:AnsiString;
                        var NotPresentNextDataInLine:boolean);
    function DiferenceInRekordForArduinoState_ComparedWithPreviousRekord : boolean;
    procedure CloseSession_CliSocket_WithRemoteChatServer;
    Procedure CutBeginningAndEnd(Var Value:string);
    procedure Display(Msg : String);
    procedure ProcessCommand(Cmd : String);
    procedure SendData;
    procedure StartServer;
    procedure SetEnableNeededElements ;
    procedure SetDisableNeededElements ;
  end;

type TClientConnection = class(TWSocketClient)
protected
    FRcvdLine : String;         { Buffer for commands              }
    FLights   : TTrafficLight;  { Client's Traffic Light Component TTrafficLight }
    FIndex    : Integer;        { Slot number as known by server   }
    procedure ConnectionDataAvailable(Sender: TObject; Error : Word);
public
    constructor Create(AOwner : TComponent); override;
end;



var
  Form1: TForm1;

implementation
uses
    OverbyteIcsUtils;  
{$R *.dfm}


constructor TClientConnection.Create(AOwner : TComponent);
begin
    inherited Create(AOwner);
    LineMode        := TRUE;
    LineEdit        := TRUE;
    LineEnd         := #13#10;
    OnDataAvailable := ConnectionDataAvailable;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure TClientConnection.ConnectionDataAvailable(Sender: TObject; Error : Word);
var I:integer;
    Command:string;
    Params:string  ;
  begin
   //First step (receive data):
    FRcvdLine := ReceiveStr;

    //Second step (command parsing):
    { Remove end of line marker }
    if Length(FRcvdLine) > 1 then
        SetLength(FRcvdLine, Length(FRcvdLine) - 2);
    { Remove unused blanks }
    FRcvdLine := Trim(FRcvdLine);
    Form1.ExtractReceivedStringFromArduino_And_PutItInGraficElements(FRcvdLine);
  end;

{ Display a message in our display memo. Delete lines to be sure to not     }
{ overflow the memo which may have a limited capacity. }
procedure TForm1.Display(Msg : String);
var
    I : Integer;
begin
    DisplayMemoCliSocket.Lines.BeginUpdate;
    try
        if DisplayMemoCliSocket.Lines.Count > 200 then begin
            for I := 1 to 50 do
                DisplayMemoCliSocket.Lines.Delete(0);
        end;
        DisplayMemoCliSocket.Lines.Add(Msg);
    finally
        DisplayMemoCliSocket.Lines.EndUpdate;
{$IFNDEF VER80}
        SendMessage(DisplayMemoCliSocket.Handle, EM_SCROLLCARET, 0, 0);
{$ENDIF}
    end;
end;



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
    IniFile : TIcsIniFile;
    IniFileServer : TIcsIniFile;
begin
   IniFile := TIcsIniFile.Create(IniFileName);
    IniFile.WriteInteger('Window', 'Top',    Top);
    IniFile.WriteInteger('Window', 'Left',   Left);
    IniFile.WriteInteger('Window', 'Width',  Width);
    IniFile.WriteInteger('Window', 'Height', Height);
    IniFile.WriteString('Data', 'Server',  ServerEdit.Text);
    IniFile.WriteString('Data', 'Port',    PortEditSockCLient.Text);
    IniFile.WriteString('Data', 'Command', SendEdit.Text);
    IniFile.UpdateFile;
    IniFile.Free;

    IniFileServer := TIcsIniFile.Create(IniFileNameServer);
    IniFileServer.WriteString('Data', 'Port', PortSocketServerEdit.Text);
    IniFileServer.Destroy;
    CloseSession_CliSocket_WithRemoteChatServer;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

 GetLocalIPList(DisplayMemoCliSocket.Lines, TSocketFamily(sfAnyIPv4));
 OwnIPAddress:= DisplayMemoCliSocket.Lines[0];
 ServerEdit.Text:='192.168.1.177'; //potem dac ze zbiou ini
 Application.ProcessMessages;
 HeaderAnalog.Sections[0] :=' Analog Pin = 1023';
 HeaderAnalog.Font.Color:= clFuchsia;
end;

procedure TForm1.FormShow(Sender: TObject);
var
    IniFile : TIcsIniFile;
    IniFileServer : TIcsIniFile;
begin
 //CliSocket.ReuseAddr:=True;
 if (Initialized  and  InitializedServer) then
    exit;

 if not Initialized
    then begin
            //Exit;
           Initialized     := TRUE;
           IniFileName     := GetIcsIniFileName;
           IniFile         := TIcsIniFile.Create(IniFileName);
           Top             := IniFile.ReadInteger('Window', 'Top',    Top);
           Left            := IniFile.ReadInteger('Window', 'Left',   Left);
           Width           := IniFile.ReadInteger('Window', 'Width',  Width);
           Height          := IniFile.ReadInteger('Window', 'Height', Height);
           PortEditSockCLient.Text   := IniFile.ReadString('Data', 'Port',    '1020');
           ServerEdit.Text := IniFile.ReadString('Data', 'Server',  '192.168.1.177');
           IniFile.Free;
           DisplayMemoCliSocket.Clear;
           ActiveControl := SendEdit;
           SendEdit.SelectAll;
           SendButtonForClientSocketClick(Sender);

         end;
 if not InitializedServer
              then begin
                    IniFileServer       := TIcsIniFile.Create('TrafficServer');
                    PortSocketServerEdit.Text := IniFileServer.ReadString('Data', 'Port', '33');
                    IniFileServer.Destroy;
                    StartServer;
                   end;
  Application.ProcessMessages;
end;
procedure TForm1.SendData;
var
    Buf : String;
    I   : Integer;
begin
    try
        Buf := SendEdit.Text;
        if AddCRLFCheckBox.Checked then
            Buf := Buf + #13#10;
        if AllowBinaryCheckBox.Checked then begin
            { Allow embedded binary characters in the editbox, encoded as }
            { $ sign followed by two digit hex asccci code ($41 = 'A')    }
            I := 1;
            while I < (Length(Buf) - 2) do begin
                if Buf[I] = '$' then begin
                    Buf := Copy(Buf, 1, I - 1) +
                           Char(StrToInt(Copy(Buf, I, 3))) +
                           Copy(Buf, I + 3, Length(Buf));
                end;
                Inc(I);
            end;
        end;
        CliSocket.SendStr(Buf);
    except
        //on E:Exception do Display(E.ClassName + ': ' + E.Message);
    end;
    ActiveControl := SendEdit;
    SendEdit.SelectAll;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.ProcessCommand(Cmd : String);
begin
    if (Length(Cmd) >= Length(CliSocket.LineEnd)) and
       (Copy(Cmd, Length(Cmd) - Length(CliSocket.LineEnd) + 1,
             Length(CliSocket.LineEnd)) = String(CliSocket.LineEnd)) then
        Cmd := Copy(Cmd, 1, Length(Cmd) - Length(CliSocket.LineEnd));
    { Then display in memo                                                  }
    Display(Cmd);
end;


{---------------------------}
Procedure TForm1.CutBeginningAndEnd(Var Value:string);
var Ipom:integer;
 begin
  if Value=' ' then Value:='';
  if Value = '' then exit;
  Ipom:=Length(Value);
  while ((Ipom>0) and (Value[Ipom]=' '))
         do begin
             delete(Value,Ipom,1);
             Ipom:=Ipom-1;
            end;
  if Value='' then exit;
  while Value[1]=' ' do  delete(Value,1,1);
  end;
{----------------}

procedure TForm1.CliSocketDataAvailable(Sender: TObject; ErrCode: Word);
var
    Len : Integer;
    s:string;
begin
   { We use line mode, we will receive a complete line }
   LocationIinLLine := 1; //dalem to dlatego iz za kazdym razem jest czytana tylko jedna Line 
    Len := CliSocket.Receive(@Buffer, SizeOf(Buffer) - 1);
    if Len <= 0 then
        Exit;
    Buffer[Len]       := #0;
    s :=String(Buffer);
    ExtractReceivedStringFromArduino_And_PutItInGraficElements(s);
    SetEnableNeededElements;
end;

procedure TForm1.SetEnableNeededElements ;

 begin
   exit;
   RVOfficeRadioGroup1.Enabled :=True;
   RVOfficeRadioGroupFirstExtend.Enabled :=True;
 end;

procedure TForm1.SetDisableNeededElements ;

 begin
    exit;
   RVOfficeRadioGroup1.Enabled :=false;
   RVOfficeRadioGroupFirstExtend.Enabled :=false;
   //RVOfficeRadioGroupSecondExtend.Enabled :=false;
 end;

procedure TForm1.CliSocketSendData(Sender: TObject; BytesSent: Integer);
var  I : integer;
begin
   I:=  BytesSent;
end;

procedure TForm1.CliSocketSessionClosed(Sender: TObject; ErrCode: Word);
begin
//CliSocket.Listen;
  DisconectButtonClientSocket.Enabled := FALSE;
    if ErrCode <> 0 then
        Display('Disconnected, error #' + IntToStr(ErrCode))
    else
        Display('Disconnected');
   RekordForArduinoPreviousState:= RekordForArduinoState;
end;

procedure TForm1.CliSocketSessionConnected(Sender: TObject; ErrCode: Word);
var s : string  ;
begin
 SendButtonForClientSocket.Enabled := TRUE;
    if ErrCode <> 0 then
        Display('Can''t connect, error #' + IntToStr(ErrCode))
    else begin
         s:= SendEdit.Text;
        DisconectButtonClientSocket.Enabled := TRUE;
        SetDisableNeededElements  ;
        SendData;  { Send the data from edit box }
    end;
end;

procedure TForm1.CloseProgramClick(Sender: TObject);
begin
 close;
end;

procedure TForm1.CloseSession_CliSocket_WithRemoteChatServer;
begin
   SendEdit.Text:='CLOSE_SESSION';
   SendButtonForClientSocketClick(Form1 ) ;
   ShowMessage('Session with chat Server was closed normally');

end;

function TForm1.DiferenceInRekordForArduinoState_ComparedWithPreviousRekord: boolean;
var I : integer;
    NoInRecord : integer;
 begin
  for I := 0 to NoOfDigitalPinsOnBoard + 2 * NoOfDigitalPinsOnExtendedPCF857X do
   begin
    if RekordForArduinoState.DigitalState[i]
                 <>
       RekordForArduinoPreviousState.DigitalState[i]
       then Result :=True;
   end;
    
 end;

procedure TForm1.StartServer;
begin
    //WSocketServer1.Close;                     { If not the first time    }
    //WSocketServer1.Proto       := 'tcp';      { Use TCP protocol         }
    //WSocketServer1.Addr        := OwnIPAddress;//'192.168.1.7';//'0.0.0.0';  { Listen on all interfaces }
    //WSocketServer1.Port        := PortSocketServerEdit.Text;{ Port to listen to      }

    //WSocketServer1.ClientClass := TClientConnection;

    //WSocketServer1.Banner      := 'Welcome on TrafficServer';
    //WSocketServer1.LineMode := TRUE;
    //WSocketServer1.LineEnd  := #13#10;
    //WSocketServer1.Listen;                    { Start listening          }
    //Display('Server is waiting for client connection');
end;

Procedure TForm1.ExtractDataFromLine(
                        Line:AnsiString;
                        var LocationIinLLine:integer;
                        var ExtractedStringData:AnsiString;
                        var NotPresentNextDataInLine:boolean);
var DlugDanej,DlugLini:integer;
    StrPom:Ansistring;
    PosCudzyslowia:byte;
begin
 if Line =''  then
  begin
   NotPresentNextDataInLine:=True;
   exit;
  end;
 if Line[1]= DataSeparator  then
      delete(Line,1,1);
 NotPresentNextDataInLine:=false;
 DlugDanej:=0;
 DlugLini:=length(Line);
 while ((Line[LocationIinLLine]=' ') and (LocationIinLLine < DlugLini))  do
                            LocationIinLLine:=LocationIinLLine+1;
                       { przesuniecie sie gdy wystepuja spacje przed dana}
 StrPom:=copy(Line,LocationIinLLine,20000);
 PosCudzyslowia:=Pos('"',Strpom);
 if PosCudzyslowia>0 then begin
                           delete(StrPom,PosCudzyslowia,1); {obciecie pierwszego cudzyslowia}
                           LocationIinLLine:=LocationIinLLine+1;
                          end;
 PosCudzyslowia:=Pos('"',Strpom);
 if PosCudzyslowia>0 then delete(StrPom,PosCudzyslowia,1); {obciecie drugiego cudzyslowia}
 //DlugDanej:=Pos(',',StrPom)-1;
 DlugDanej:=Pos(DataSeparator,StrPom)-1;
 if DlugDanej < {=} 0 then DlugDanej:=length(StrPom);
       {wystepuje tylko jeden symbol prefiksu zakonczony srednikiem ;
          w 2-giej linii kraju}
 ExtractedStringData:=copy(Line,LocationIinLLine,DlugDanej);
 if PosCudzyslowia>0 then LocationIinLLine:=LocationIinLLine+1;
 LocationIinLLine:=LocationIinLLine+length(ExtractedStringData)+1;
 if (LocationIinLLine >= length(Line))  then
   begin
    NotPresentNextDataInLine:=True;
    exit;
   end;
 while ((Line[LocationIinLLine]=' ') and (LocationIinLLine < DlugLini))  do LocationIinLLine:=LocationIinLLine+1;
                { przesuniecie sie gdy wystepuja spacje przed nastepna dana}
  if LocationIinLLine >= DlugLini then NotPresentNextDataInLine:=True;
end;
{--------------}



procedure TForm1.ExtractReceivedStringFromArduino_And_PutItInGraficElements(var StringReceived:string);
var
  Dial_text: string;
  analogChannel: Integer;
  LineReceived: string;
  ValueForPin: Integer;
  digitalChannel: Integer;
  digitalChannelForPCF8576 , digitalChannelForPCF8576_1 : Integer;
  ValueForDislay: Integer;
begin
  LocationIinLLine := 1; 
  LineReceived := StringReceived;
  CutBeginningAndEnd(LineReceived);
  ProcessCommand(LineReceived);
  { Pass as string }
  LineReceived := StringReplace(LineReceived, ''#13''#10'', '', [rfReplaceAll, rfIgnoreCase]);
  LineReceived := StringReplace(LineReceived, ''#10''#10'', '', [rfReplaceAll, rfIgnoreCase]);
  CutBeginningAndEnd(LineReceived);
  repeat
    ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
    //type type TTypeLine = (Analog, Digital,PCF8576,PCF8576_1,Null) ;
    if ExtractedStringData = 'A'
       then TypeLine := Analog
       else if ExtractedStringData = 'D'
          then TypeLine := Digital
          else if ExtractedStringData = 'P'
            then TypeLine := PCF8576
            else if ExtractedStringData = 'R'
               then TypeLine := PCF8576_1
               else TypeLine := Null;
    ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
    case TypeLine of
      Analog:
        begin
          analogChannel := StrToInt(ExtractedStringData);
          if analogChannel = 0
           then begin
                //kanal zerowy dla potencjometru
                 ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
                 CutBeginningAndEnd(ExtractedStringData);
                 HeaderAnalog.Sections[analogChannel] := 'Analog Pin ' + IntToStr(analogChannel) + '=' + ExtractedStringData;
                 ValueForPin := StrToInt(ExtractedStringData);
                 RekordForArduinoState.AnalogState[analogChannel] := ValueForPin;
                 ValueForDislay := TRunc((ValueForPin / 1023) * 360);
                 AdvSmoothGauge2.Value := ValueForDislay;
                 Dial_text := IntToStr(ValueForDislay);
                 AdvSmoothGauge2.DialText := Dial_text;
                 AdvSmoothGauge2.Invalidate;
               end
          else begin
                 ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
                 CutBeginningAndEnd(ExtractedStringData);
                 ValueForPin := StrToInt(ExtractedStringData);
                 RekordForArduinoState.AnalogState[analogChannel] := ValueForPin;
                  HeaderAnalog.Sections[analogChannel] := 'Analog Pin ' + IntToStr(analogChannel) + '=' + ExtractedStringData;
               end;
        end;
      Digital:
        begin
          digitalChannel := StrToInt(ExtractedStringData);
          ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
          CutBeginningAndEnd(ExtractedStringData);
          ValueForPin := StrToInt(ExtractedStringData);
          RekordForArduinoState.DigitalState[digitalChannel] := boolean(ValueForPin);
          RVOfficeRadioGroup1.Items[digitalChannel].Caption := 'Pin No '
                      + IntToStr(digitalChannel) + '=' + ExtractedStringData;
          if ExtractedStringData = '0' then
            RVOfficeRadioGroup1.Items[digitalChannel].FillColor := clMenuHighlight
          else
            RVOfficeRadioGroup1.Items[digitalChannel].FillColor := clWindow;
        end;

      PCF8576:
        begin
         digitalChannelForPCF8576 := StrToInt(ExtractedStringData);
         ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
         CutBeginningAndEnd(ExtractedStringData);
         ValueForPin := StrToInt(ExtractedStringData);
         RekordForArduinoState.DigitalState[1+NoOfDigitalPinsOnBoard +  digitalChannelForPCF8576]
                         := boolean(ValueForPin);
         RVOfficeRadioGroupFirstExtend.Items[digitalChannelForPCF8576].Caption := 'Pin No '
                                      + IntToStr(digitalChannelForPCF8576) + '=' + ExtractedStringData;
          if ExtractedStringData = '0' then
            RVOfficeRadioGroupFirstExtend.Items[digitalChannelForPCF8576].FillColor := clMenuHighlight
          else
            RVOfficeRadioGroupFirstExtend.Items[digitalChannelForPCF8576].FillColor := clWindow;
        end;

      PCF8576_1:

        begin
          digitalChannelForPCF8576_1 := StrToInt(ExtractedStringData);
         ExtractDataFromLine(LineReceived, LocationIinLLine, ExtractedStringData, NotPresentNextDataInLine);
         CutBeginningAndEnd(ExtractedStringData);
         ValueForPin := StrToInt(ExtractedStringData);
         RekordForArduinoState.DigitalState[1+NoOfDigitalPinsOnBoard
                +  NoOfDigitalPinsOnExtendedPCF857X + digitalChannelForPCF8576_1] := boolean(ValueForPin);
        end;
    end;
  until NotPresentNextDataInLine or (TypeLine = Null);
end;



procedure TForm1.DisconectButtonClientSocketClick(Sender: TObject);
begin
  CliSocket.Flush;
 CliSocket.Close;
end;

procedure TForm1.SetStateSendEditComponent_and_RekordForArduino (var NrPinForSingle:integer ;
                                                                 var NoItemCorectedInRecordArduino: integer;
                                                                 TypePin:char);
var
  StrPom: string;
  I: Integer;
  StateDigitalPinBoolean: Boolean;
begin

case ChoiceTrybeWork.ItemIndex of
  0 : begin   //string for all ports
       StateDigitalPinBoolean := RekordForArduinoState.DigitalState[NoItemCorectedInRecordArduino];
       StateDigitalPinBoolean := not StateDigitalPinBoolean;
       RekordForArduinoState.DigitalState[NoItemCorectedInRecordArduino] := StateDigitalPinBoolean;
       if DiferenceInRekordForArduinoState_ComparedWithPreviousRekord then
      begin
       for I := 0 to NoOfDigitalPinsOnBoard + 2 * NoOfDigitalPinsOnExtendedPCF857X do //for 2 extender PCF8574
        begin
         StrPom := IntToStr(integer(RekordForArduinoState.DigitalState[i]));
         SendEdit.Text := SendEdit.Text + StrPom;
        end;
        end;
       end;

  1: begin  //string for change single  ports
       StateDigitalPinBoolean := RekordForArduinoState.DigitalState[NoItemCorectedInRecordArduino];
       StateDigitalPinBoolean := not StateDigitalPinBoolean;
       RekordForArduinoState.DigitalState[NoItemCorectedInRecordArduino] := StateDigitalPinBoolean;
       StrPom := IntToStr(integer(RekordForArduinoState.DigitalState[NoItemCorectedInRecordArduino])); //0 or 1
       case TypePin of
         'D' : begin
                 if NrPinForSingle < 10
                    then SendEdit.Text := 'S D ' +   IntToStr(NrPinForSingle) + ' ' + StrPom
                    else SendEdit.Text := 'S D ' +   IntToStr(NrPinForSingle) + StrPom;
               end;
          'P' : begin  //first extender
                if NrPinForSingle < 10
                    then SendEdit.Text := 'S P ' +   IntToStr(NrPinForSingle) + ' ' +  StrPom
                    else SendEdit.Text := 'S P ' +   IntToStr(NrPinForSingle) + StrPom;
                end ;
           'R': begin   //second extender
                 if NrPinForSingle < 10
                    then SendEdit.Text := 'S R ' +   IntToStr(NrPinForSingle) + ' ' + StrPom
                    else SendEdit.Text := 'S R ' +   IntToStr(NrPinForSingle) + StrPom;
                end;

       end; //case
     end;
end;  // case ChoiceTrybeWork.ItemIndex of

    SendButtonForClientSocketClick(Form1);
    RekordForArduinoPreviousState := RekordForArduinoState;
end;


procedure TForm1.RVOfficeRadioGroup1Click(Sender: TObject);
var ItemNr: integer;

begin
 SendEdit.Text := '';
 ItemNr:=RVOfficeRadioGroup1.ItemIndex;
 NoItemCorectedInRecordArduino:= ItemNr;//+1;
 SetStateSendEditComponent_and_RekordForArduino (ItemNr, NoItemCorectedInRecordArduino ,'D');
end;

procedure TForm1.RVOfficeRadioGroup1DblClickItem(Sender: TObject);
var ItemNr: integer;
begin
 SendEdit.Text := '';
 ItemNr:=RVOfficeRadioGroup1.ItemIndex;
 NoItemCorectedInRecordArduino:= ItemNr;  //+1;
 SetStateSendEditComponent_and_RekordForArduino (ItemNr, NoItemCorectedInRecordArduino ,'D');
end;

procedure TForm1.RVOfficeRadioGroupFirstExtendClick(Sender: TObject);
var ItemNr: integer;
begin
 SendEdit.Text := '';
 ItemNr:=RVOfficeRadioGroupFirstExtend.ItemIndex;
 NoItemCorectedInRecordArduino:=NoOfDigitalPinsOnBoard+ ItemNr +1;
 SetStateSendEditComponent_and_RekordForArduino (ItemNr, NoItemCorectedInRecordArduino ,'P');
end;

procedure TForm1.RVOfficeRadioGroupFirstExtendDblClickItem(Sender: TObject);
var ItemNr: integer;
begin
  SendEdit.Text := '';
 ItemNr:=RVOfficeRadioGroupFirstExtend.ItemIndex;
 NoItemCorectedInRecordArduino:= NoOfDigitalPinsOnBoard + ItemNr+ 1;
 SetStateSendEditComponent_and_RekordForArduino (ItemNr, NoItemCorectedInRecordArduino ,'P');
end;

procedure TForm1.SendButtonForClientSocketClick(Sender: TObject);
begin
 if CliSocket.State = wsConnected then begin
        { Already connected, just send data }
        SendData;
    end
    else begin
        { Not connected yet, start connection }
        CliSocket.Proto    := 'tcp';     //take attention = this  CliSocket work with Protocol = tcp , what is protocol connected
                                         //that means that datagram is control if was supplied  to destination
                                         //not as UDP = where this control is not do - sou UDP can be not supplied to destination

        CliSocket.Port     := PortEditSockCLient.Text;
        CliSocket.Addr     := ServerEdit.Text;
        CliSocket.LineMode := TRUE;
        CliSocket.LineEnd  := #13#10;
        CliSocket.Connect;
        { Connect is asynchronous (non-blocking). When the session is  }
        { connected (or fails to), we have an OnSessionConnected event }
        { This is where actual sending of data is done.                }
        //SendButtonForClientSocket.Enabled := FALSE;

    end;
end;

end.
